freeslot("sfx_dblthk")

sfxinfo[sfx_dblthk] = {
   singular = false,
   caption = "Double Thok!"
}

addHook("PlayerSpawn", function(player)
if player.sprung == nil
player.sprung = false
end
end)

addHook("PlayerThink", function(player)
if player and player.mo and player.valid and player.mo.valid 
and player.mo.eflags & MFE_SPRUNG or player.powers[pw_justsprung] 
and not P_IsObjectOnGround(player.mo) and not player.bot then
player.sprung = true
player.cansecondthok = false
end
end)

local function firstthok(p)
	if p.mo and p.mo.skin == "sonic"
	and not (p.pflags & PF_THOKKED)
		P_InstaThrust(p.mo, p.mo.angle, 60*FRACUNIT)
		P_SetObjectMomZ(p.mo, 17*FRACUNIT/4)
		local secthokring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THIK)
		secthokring.scale = 3*p.mo.scale/2
		P_SpawnThokMobj(p)
		p.mo.state = S_PLAY_ROLL
		S_StartSound(p.mo, sfx_zoom)
		S_StartSound(p.mo, sfx_thok)
		p.cansecondthok = true
		p.pflags = $|PF_THOKKED
		return true
	end
end

addHook("AbilitySpecial", firstthok)

local function secondthok(p)
	if p.mo and p.mo.skin == "sonic"
	and not (p.pflags & PF_JUMPDOWN)
	and not P_IsObjectOnGround(p.mo)
	and p.cansecondthok == true then
		P_InstaThrust(p.mo, p.mo.angle, 65*FRACUNIT)
		P_SetObjectMomZ(p.mo, 17*FRACUNIT/4)
		local secthokring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THIK)
		secthokring.scale = 3*p.mo.scale/2
		S_StartSound(p.mo, sfx_dblthk)
		S_StartSound(p.mo, sfx_thok)
		p.cansecondthok = false
		P_SpawnThokMobj(p)
		p.pflags = $|PF_THOKKED
		p.mo.state = S_PLAY_FALL
	end
end

addHook("JumpSpecial", secondthok)

local function cancelthokthing(p)
     if p and p.mo.skin == "sonic"
     and P_IsObjectOnGround(p.mo)
	 and p.cansecondthok == true
	 p.cansecondthok = false
	 p.sprung = false
  end
end

addHook("PlayerThink", cancelthokthing)

local function secthokghost(p)
     if p and p.mo.skin == "sonic"
	 and p.mo.state == S_PLAY_FALL
	 and not P_IsObjectOnGround(p.mo)
	 if S_SoundPlaying(p.mo, sfx_dblthk)
	 local spooky = P_SpawnGhostMobj(p.mo)
	 spooky.fuse = 4
	 spooky.color = p.mo.color
	 spooky.colorized = true
	end
  end
end

addHook("PlayerThink", secthokghost)